# -*- coding: utf-8 -*
from __future__ import print_function
import numpy as np 
import cv2

# Adaptive cutting edge
# x,y cutting weight is obtained by trial and error
def mask(image,v,k):
	canvas = np.ones(image.shape[:2],dtype = "uint8")*255
	x = image.shape[1]
	y = image.shape[0]
	black = (0,0,0)
	k = None
	if v == "panel.mpg" :
		k = 1
	elif v == "panel.mp4" :
		k = 1
	elif v == "panell.mp4" :
		k = 2
	elif v == "panelc.mp4" :
		k = 2
	elif v == "panel2.mp4" :
		k = 3
	elif v == "panelcc.mp4" :
		k = 4
	else:
		k = 2
	if k == None:
		print("############################ ERROR ！############################")
		print("# Error may cause by:")
		print("#	A. New Video (unknown edge elimination information)")
		print("#		please modify creat.py")
		print("#	B. Camera data input")
		print("############################ ERROR ！############################")
	elif k == 1:
		# Orientation 方位角
		cv2.rectangle(canvas, (10,48),(x-10,0),black,-1)
		# Bottom(time) 底部信息（时间）
		cv2.rectangle(canvas, (10,y),(x-10,512),black,-1)
		# Left-up corner 左上角
		cv2.rectangle(canvas, (10,150),(110,45),black,-1)
		# Right-up corner 右上角
		cv2.rectangle(canvas, (600,105),(x-10,45),black,-1)
		# L&R side 左右黑边
		cv2.rectangle(canvas, (0,y),(12,0),black,-1)
		cv2.rectangle(canvas, (x-12,y),(x,0),black,-1)
	elif k == 4:
		# Orientation 方位角
		cv2.rectangle(canvas, (5,55),(x-5,0),black,-1)
		# Left_up AUR-Lab inf 实验室 左上角
		cv2.rectangle(canvas, (5,120),(210,55),black,-1)
		# Right-up Orientation inf 方位角信息 右上角
		cv2.rectangle(canvas, (x-195,140),(x-5,55),black,-1)
		# Left-down VDepth and Turn 深度 转角？ 左下角
		cv2.rectangle(canvas, (5,y),(185,y-90),black,-1)
		# Right-down Time & Date 日期 时间  右下角
		cv2.rectangle(canvas, (x-140,y),(x-5,y-95),black,-1)
		# L&R side 左右黑边
		cv2.rectangle(canvas, (0,y), (5,0),black,-1)
		cv2.rectangle(canvas, (x-5,y),(x,0),black,-1)
		# Bottom(time) 底部信息（时间）
		cv2.rectangle(canvas, (0,y),(x,y-5),black,-1)
	elif k == 2:
		# Orientation 方位角
		cv2.rectangle(canvas, (5,80),(x-5,0),black,-1)
		# Left_up AUR-Lab inf 实验室 左上角
		cv2.rectangle(canvas, (5,175),(310,80),black,-1)
		# Right-up Orientation inf 方位角信息 右上角
		cv2.rectangle(canvas, (x-280,205),(x-5,80),black,-1)
		# Left-down VDepth and Turn 深度 转角？ 左下角
		cv2.rectangle(canvas, (5,y),(275,945),black,-1)
		# Right-down Time & Date 日期 时间  右下角
		cv2.rectangle(canvas, (x-210,y),(x-5,945),black,-1)
		# Bottom 底边
		cv2.rectangle(canvas, (275,y),(x-210,y-5),black,-1)
		# L&R side 左右黑边
		cv2.rectangle(canvas, (0,y), (5,0),black,-1)
		cv2.rectangle(canvas, (x-5,y),(x,0),black,-1)
	elif k == 3:
		# Top 顶部
		cv2.rectangle(canvas, (0,5), (x,0),black,-1)
		# Left_up AUR-Lab inf 实验室 左上角
		cv2.rectangle(canvas, (5,135),(180,0),black,-1)
		# Right-up Orientation inf 方位角信息 右上角
		cv2.rectangle(canvas, (x-205,75),(x-5,0),black,-1)
		# L&R side 左右黑边
		cv2.rectangle(canvas, (0,y), (20,0),black,-1)
		cv2.rectangle(canvas, (x-23,y),(x,0),black,-1)
		# Bottom 底部
		cv2.rectangle(canvas, (0,y), (x,y-5),black,-1)

 	return canvas,k