# -*- coding: utf-8 -*
from __future__ import division
import numpy as np 
import argparse
import time
import cv2


# new package
import creat
import camera_tracking
import Intervention
import edge_detect
import visual_guidance

# 还没想好怎么解决这个问题
import UDP





# ===============================================
# Reading video other video file from disk
# Terminal command format:
# python valvetrack_v2.py --video /users/liboxue/desktop/panelvideo/panel.mpg

ap = argparse.ArgumentParser()
ap.add_argument("-v", "--video",
	help = "path to the (optional) video file")
args = vars(ap.parse_args())
camera = cv2.VideoCapture(args["video"])
v = args["video"]

# ===============================================




while True:
	# Grabbing a frame
	(grabbed, frame) = camera.read()
	if not grabbed:
		break

	k = None
	if args["video"] == "panel.mpg" :
		k = 1
	elif args["video"] == "panel.mp4" :
		k = 1
	elif args["video"] == "panell.mp4" :
		k = 2
	elif args["video"] == "panelc.mp4" :
		k = 2
	elif args["video"] == "panel2.mp4" :
		k = 3
	elif args["video"] == "panelcc.mp4" :
		k = 4

	# Creat canvas for edge elimination
	(canvas,k) = creat.mask(frame,v,k)
	if k == None:
		break
	# Convert to HSV color space
	HSVframe = cv2.cvtColor(frame, cv2.COLOR_BGR2HSV)
	chans = cv2.split(HSVframe)#
	grayframe = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)

	# print(grayframe.shape)
	# Erode or Dilate kernel
	erode_kernel_25 = cv2.getStructuringElement(cv2.MORPH_ELLIPSE,(25,25))
	dilate_kernel_25 = erode_kernel_25
	# close shadow kernel
	# k = 10# 200 或更高可以突出暗处结构，可以用在后续检测valve横梁结构 #10 P3会在初始无法探测出来    #6
	shadow_kernel = cv2.getStructuringElement(cv2.MORPH_RECT,(10, 10))
	# dilate_kernel_25 = cv2.getStructuringElement(cv2.MORPH_ELLIPSE,(25,25))

	# visual_guidance.lineDetection(frame,chans,canvas)

	###################
	# Panel detection #
	###################

	# 可以先用 color_based detection combine with v-s detection 作为 4月6日的 panel检测方案，后面还是引入AI比较好
	# 有个问题，就是根据前后给出的两个 panel 视频中 panel 表面灰尘情况预计，如果放置在水下一定时间的 水下结构，很有可能
	# 会因海洋生物附着，海底灰尘沉降附着表面等，导致 基于机器学习的 方法受干扰，检测精度下降甚至失效。

	# temp
	(inf,ik) = camera_tracking.PanelDetect(chans,canvas,dilate_kernel_25,imshow = 0	) 


	###################
	# Edge detection #
	###################

	#这个 panel edge detection 算法应该再我们向panel移动的过程中启动，以便锁定panel的一些结构特征点，canny的thre2
	# 可以设置的第一点，因为这个阶段的结构比较明显




	ik = 1
	# SLAM 要替换成 visual_guidance 了
	# ik = 1 line + mani
	# ik = 2 调整altitude
	# ik = 3 Obstacle Avoidance?
	# temp
	if ik == 3:
		print(inf)
		break
	elif ik == 2:
		print(inf)
		print("#####  Please keep altitude at panel height!  #####")
		# SLAM 在 Ubuntu 中，需要：胶水连接 或者 将此处 python 脚本转置为 c++ 脚本
	elif ik == 1:
		print(inf)
		# 如果 color detect 没有结果，则不开启line
		print("#####  Line Detection start  #####")
		# SLAM 在 Ubuntu 中，需要：胶水连接 或者 将此处 python 脚本转置为 c++ 脚本
		# label detection 开启条件应该是： altitude = panel height && line detection
		# line 开启，并且 altitude 达到 panel height ，才开启 label detection
		print("#####  Label Detection start  #####")
		lcnts = Intervention.LabelDetect(HSVframe,grayframe,chans,canvas,dilate_kernel_25,shadow_kernel,imshow = 1)
		
		# LabelDetect(HSVframe,chans,mask,erode_kernel,k = 10, imshow = 0)
	
	# 输入 上一步的 lcnts：
	# 在上一步 mani start 给出 lcnts 结果后，应该先判断筛选一下，那些 contours 对应的是label，把误识别的 contour 
	# 去掉。
	# 筛选方案：	1. Machine Learning
	# 			2. 基于 基础视觉方法，比如 label 区域分割更明显一些， 在interven 中用 ostu 插在 histogram equalization
	# 				之前
	# 			3. 其他， maybe， 基于基础视觉，找出 panel 区域， 然后 dilate 减小这个区域，这样或许能减小 valve
					# 边缘的干扰，然后这个作为 mask 去套 LabelDetect 的结果，看看是否效果会好些呢 
	# 经过筛选后输出新的  return lcnts
	# temp 
	# 用来比较的，后期可以删掉
	if len(lcnts) >0:
		# pointlist = []
		for i in range(len(lcnts)):
			k = cv2.minAreaRect(lcnts[i])
			print("k",k)
			kx = k[1][0]
			ky = k[1][1]
			print("kx",kx,"ky",ky)
			area = kx*ky
			print("area",area)
			# k1 = (int(k[0][0]),int(k[0][1]))
			# k2 = (int(k[1][0]),int(k[1][1]))
			if kx>ky:
				kr = kx/(ky+0.01)
			else:
				kr = ky/(kx+0.01)
			if 500<area<5000 and 0.25<=kr<=4:
				rect = np.int32(cv2.boxPoints(cv2.minAreaRect(lcnts[i])))
				# print("rect",rect)
				cv2.drawContours(frame, [rect],-1,(0,0,255),3)
			# if kx>ky and 1.4<=kr1<=3.2:
			# 	rect = np.int32(cv2.boxPoints(cv2.minAreaRect(lcnts[i])))
			# 	print("rect",rect)
			# 	cv2.drawContours(label11, [rect],-1,(255,255,255),1)
			# elif kx<ky and 1.4<=kr2<=3.2:
			# 	rect = np.int32(cv2.boxPoints(cv2.minAreaRect(lcnts[i])))
			# 	cv2.drawContours(label11, [rect],-1,(255,255,255),1)
			# 	print("rect",rect)
			# else:
			# 	continue

	# if ik == 1:
	# 	if len(lcnts) >0:
	# 		# pointlist = []
	# 		for i in range(len(lcnts)):
	# 			k = cv2.minAreaRect(lcnts[i])
	# 			k1 = (int(k[0][0]),int(k[0][1]))
	# 			k2 = (int(k[1][0]),int(k[1][1]))
	# 			rect = np.int32(cv2.boxPoints(cv2.minAreaRect(lcnts[i])))
	# 			# cv2.drawContours(frame, [rect],-1,(0,255,0),2)
	# 			# cv2.drawContours(frame, [rect],-1,(255,255,255),2)

	th = cv2.bitwise_and(frame,frame,mask = canvas)
	# cv2.imshow("cvtColor",th)
	cv2.imshow("label segmentation",frame)


	if cv2.waitKey(1) & 0xFF == ord("q"):
		break

camera.release()
cv2.destroyAllWindows()