import numpy as np 
import argparse
import cv2

def canny(grayframe,shadow_kernel,imshow = 1):
	image = closed = cv2.morphologyEx(grayframe, cv2.MORPH_CLOSE,shadow_kernel)
	image = cv2.bilateralFilter(image,25,9,9)
	# image = cv2.GaussianBlur(closed,(5,5),0)
	canny = cv2.Canny(image, 3, 50)
	if imshow == 1:
		cv2.imshow("Blurred",image)
		cv2.imshow("Canny",canny)
	return canny